"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MinimalForwarderContract = void 0;
const objects_1 = require("@snickerdoodlelabs/objects");
const inversify_1 = require("inversify");
const neverthrow_1 = require("neverthrow");
const BaseContract_js_1 = require("../implementations/BaseContract.js");
const index_js_1 = require("../interfaces/objects/index.js");
let MinimalForwarderContract = class MinimalForwarderContract extends BaseContract_js_1.BaseContract {
    constructor(providerOrSigner, contractAddress) {
        super(providerOrSigner, contractAddress, index_js_1.ContractsAbis.MinimalForwarderAbi.abi);
        this.providerOrSigner = providerOrSigner;
        this.contractAddress = contractAddress;
    }
    getContractAddress() {
        return this.contractAddress;
    }
    getNonce(from) {
        return neverthrow_1.ResultAsync.fromPromise(this.contract.getNonce(from), (e) => {
            return this.generateError(e, `Unable to call getNonce(${from})`);
        }).map((nonce) => {
            return (0, objects_1.BigNumberString)(nonce.toString());
        });
    }
    verify(request, signature) {
        return neverthrow_1.ResultAsync.fromPromise(this.contract.verify(request, signature), (e) => {
            return this.generateError(e, `Unable to call verify()`);
        });
    }
    execute(request, signature, overrides) {
        return this.writeToContract("execute", [request, signature], overrides);
    }
    generateContractSpecificError(msg, reason, e) {
        return new objects_1.MinimalForwarderContractError(msg, reason, e);
    }
};
MinimalForwarderContract = __decorate([
    (0, inversify_1.injectable)()
], MinimalForwarderContract);
exports.MinimalForwarderContract = MinimalForwarderContract;
//# sourceMappingURL=MinimalForwarderContract.js.map