"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiftContract = void 0;
const objects_1 = require("@snickerdoodlelabs/objects");
const inversify_1 = require("inversify");
const neverthrow_1 = require("neverthrow");
const BaseContract_js_1 = require("../implementations/BaseContract.js");
const index_js_1 = require("../interfaces/objects/index.js");
let SiftContract = class SiftContract extends BaseContract_js_1.BaseContract {
    constructor(providerOrSigner, contractAddress) {
        super(providerOrSigner, contractAddress, index_js_1.ContractsAbis.SiftAbi.abi);
        this.providerOrSigner = providerOrSigner;
        this.contractAddress = contractAddress;
    }
    getContractAddress() {
        return this.contractAddress;
    }
    checkURL(domain) {
        // Returns the tokenURI or string
        // eg. 'www.sift.com/VERIFIED', 'www.sift.com/MALICIOUS' or 'NOT VERIFIED'
        return neverthrow_1.ResultAsync.fromPromise(this.contract.checkURL(domain), (e) => {
            return this.generateError(e, `Unable to call checkURL(${domain})`);
        });
    }
    // Sets a domain as VERIFIED
    verifyURL(domain, overrides) {
        return this.writeToContract("verifyURL", [domain], overrides);
    }
    // Sets a domain as MALICIOUS
    maliciousURL(domain, overrides) {
        return this.writeToContract("maliciousURL", [domain], overrides);
    }
    setBaseURI(baseUri, overrides) {
        return this.writeToContract("setBaseURI", [baseUri], overrides);
    }
    generateContractSpecificError(msg, reason, e) {
        return new objects_1.SiftContractError(msg, reason, e);
    }
};
SiftContract = __decorate([
    (0, inversify_1.injectable)()
], SiftContract);
exports.SiftContract = SiftContract;
//# sourceMappingURL=SiftContract.js.map